## hart-software-services 2022.10

=== Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Toplevel HSS Makefile
#

SHELL=/bin/sh

#
# To build the HSS under SoftConsole on Windows, we need to use SoftConsole-provided
# tools, and potentially to modify paths
#

.ONESHELL:

include application/os.mk

include application/Makefile
include .config

ifneq ("$(wildcard boards/${BOARD}/Makefile)","")
  include boards/${BOARD}/Makefile
else
  ifndef BOARD
    BOARD:=mpfs-icicle-kit-es
    export BOARD
    $(info INFO: BOARD not specified, defaulting to ${BOARD}) # default to icicle if nothing found
    include boards/${BOARD}/Makefile
  else
    $(error Board >>${BOARD}<< not found)
  endif
endif

CORE_CFLAGS+=-DBOARD=${BOARD}

MCMODEL=-mcmodel=medany

include application/rules.mk
include application/targets.mk
include init/Makefile
include baremetal/Makefile
include services/Makefile
include modules/Makefile

LIBS =

#$(info $$INCLUDES is [${INCLUDES}])

ifdef CONFIG_CC_USE_MAKEDEP
  DEPENDENCIES=$(SRCS-y:.c=.d) $(EXTRA_SRCS-y:.c=.d) $(TEST_SRCS:.c=.d) $(ASM_SRCS:.S=.d) $(ASM_SRCS-y:.S=.d)
  .PHONY: dep
  dep: $(DEPENDENCIES)

  -include $(DEPENDENCIES)
endif

ifdef CONFIG_DISPLAY_TOOL_VERSIONS
include/tool_versions.h:
	echo \#define CC_VERSION_STRING \"`$(CC) --version | head -n 1`\" > include/tool_versions.h
	echo \#define LD_VERSION_STRING \"`$(LD) --version | head -n 1`\" >> include/tool_versions.h

DEPENDENCIES+=include/tool_versions.h
endif

include envm-wrapper/Makefile

################################################################################################
#
# Main Build Targets
#

OBJS-envm = $(OBJS)
EXTRA_OBJS-envm = $(EXTRA_OBJS)

OBJS-l2scratch = $(OBJS)
EXTRA_OBJS-l2scratch = $(EXTRA_OBJS)

define main-build-target
	$(ECHO) " LD        $@";
	$(CC) -T $(LINKER_SCRIPT-$(1)) $(CFLAGS_GCCEXT) $(OPT-y) \
		 -static -nostdlib -nostartfiles -nodefaultlibs \
		 -Wl,--build-id -Wl,-Map=$(BINDIR)/output-$(1).map -Wl,--gc-sections \
		 -o $(BINDIR)/$@ $(OBJS-$(1)) $(EXTRA_OBJS-$(1)) $(LIBS) $(LIBS-y)
	$(ECHO) " NM        `basename $@ .elf`.sym";
	$(NM) -n $(BINDIR)/$@ > $(BINDIR)/`basename $@ .elf`.sym
endef

#
# Build Targets
#

$(TARGET-envm): $(OBJS) $(EXTRA_OBJS) config.h  $(DEPENDENCIES) $(LINKER_SCRIPT-envm) $(LIBS)
	$(call main-build-target,envm)
	$(ECHO) " BIN       `basename $@ .elf`.bin"
	$(OBJCOPY) -O binary $(BINDIR)/$@ $(BINDIR)/`basename $@ .elf`.bin
	$(ECHO) " HEX       `basename $@ .elf`.hex";
	$(OBJCOPY) -O ihex $(BINDIR)/$@ $(BINDIR)/`basename $@ .elf`.hex
	$(SIZE) $(BINDIR)/$(TARGET-envm) 2>/dev/null

$(TARGET-l2scratch): $(OBJS) $(EXTRA_OBJS) config.h  $(DEPENDENCIES) $(LINKER_SCRIPT-l2scratch) $(LIBS) $(LIBS-y)
	$(call main-build-target,l2scratch)
	$(ECHO) " BIN       `basename $@ .elf`.bin"
	$(OBJCOPY) -O binary $(BINDIR)/$@ $(BINDIR)/`basename $@ .elf`.bin
	$(SIZE) $(BINDIR)/$(TARGET-l2scratch) 2>/dev/null

$(BINDIR)/$(TARGET-envm): $(TARGET-envm)
$(BINDIR)/$(TARGET-l2scratch): $(TARGET-l2scratch)

$(TARGET-ddr): $(OBJS) $(EXTRA_OBJS) config.h  $(DEPENDENCIES) $(LINKER_SCRIPT-ddr) $(LIBS)
	$(call main-build-target,ddr)

=== application/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
#

all: $(TARGETS) config.h
include .config

SRCS-y += \
    application/hart0/hss_state_machine.c \
    application/hart0/hss_clock.c \
    application/hart0/hss_registry.c \

INCLUDES +=\
    -I./include \
    -I.

ASM_SRCS += \
    application/crt.S \


EXTRA_SRCS-y += \
    application/hart0/hss_init.c \
    application/hart0/hss_main.c

application/hart0/hss_main.o: CFLAGS=$(CFLAGS_GCCEXT)
application/hart0/hss_init.o: CFLAGS=$(CFLAGS_GCCEXT)
application/hart0/hss_init.o: include/tool_versions.h
application/hart0/hss_state_machine.o: CFLAGS=$(CFLAGS_GCCEXT)
tools/bin2chunks/bootImage.o: CFLAGS=$(CFLAGS_GCCEXT)

#
# U54 Functionality

EXTRA_SRCS-y += \
        application/hart1-4/u54_handle_ipi.c \
        application/hart1-4/u54_state.c \

application/hart1-4/u54_handle_ipi.o: CFLAGS=$(CFLAGS_GCCEXT)

=== baremetal/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Baremetal Drivers and HAL Support

EXTRA_SRCS-y += \
	baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_pdma/mss_pdma.c \

ifdef CONFIG_PLATFORM_MPFS
EXTRA_SRCS-$(CONFIG_SERVICE_QSPI) += \
	baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_qspi/mss_qspi.c \

EXTRA_SRCS-$(CONFIG_SERVICE_MMC) += \
	baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_mmc/mss_mmc.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_mmc/mss_mmc_if.c \

EXTRA_SRCS-$(CONFIG_USE_IHC) += \
	baremetal/drivers/fpga_ip/miv_ihc/miv_ihc.c \

endif

EXTRA_SRCS-$(CONFIG_PLATFORM_MPFS) += \
	baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_mmuart/mss_uart.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_sys_services/mss_sys_services.c \
	baremetal/drivers/mss/mss_watchdog/mss_watchdog.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_mpu.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_peripherals.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_plic.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_l2_cache.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_util.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_nwc_init.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_io.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_pll.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_pmp.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_sgmii.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/startup_gcc/system_startup.c \

ifndef CONFIG_SKIP_DDR
EXTRA_SRCS-$(CONFIG_PLATFORM_MPFS) += \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_ddr.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_ddr_debug.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_ddr_test_pattern.c \

endif

ASM_SRCS += \
 	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/startup_gcc/mss_utils.S \

	# baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/startup_gcc/mss_mutex.S \

INCLUDES += \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_mmuart \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_mmc \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_qspi \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_pdma \
        -Ibaremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_sys_services \
	-Ibaremetal/drivers/mss/mss_watchdog \
	-Ibaremetal/drivers/fpga_ip/miv_ihc \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/hal \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/ \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/startup_gcc \

baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_mmc/mss_mmc.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_qspi/mss_qspi.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_mmuart/mss_uart.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_pdma/mss_pdma.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/drivers/mss/mss_watchdog/mss_watchdog.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/drivers/fpga_ip/miv_ihc/miv_ihc.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/startup_gcc/system_startup.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_nwc_init.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_ddr.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_ddr_debug.o: CFLAGS=$(CFLAGS_GCCEXT) -DHSS
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_io.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_pll.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_sgmii.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_l2_cache.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_util.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_sys_services/mss_sys_services.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_mpu.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_peripherals.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_plic.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_pmp.o: CFLAGS=$(CFLAGS_GCCEXT)

#################################################################################################
#
# USB

ifdef CONFIG_PLATFORM_MPFS
INCLUDES += \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_gpio \

SRCS-$(CONFIG_SERVICE_USBDMSC) += \
	baremetal/drivers/mss/mss_usb/mss_usb_common_cif.c \
	baremetal/drivers/mss/mss_usb/mss_usb_device.c \
	baremetal/drivers/mss/mss_usb/mss_usb_device_cif.c \
	baremetal/drivers/mss/mss_usb/mss_usb_device_msd.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/hal/hal_irq.c \
	baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_gpio/mss_gpio.c \

endif

baremetal/drivers/mss/mss_usb/mss_usb_common_cif.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/drivers/mss/mss_usb/mss_usb_device.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/drivers/mss/mss_usb/mss_usb_device_cif.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/drivers/mss/mss_usb/mss_usb_device_msd.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/hal/hal_irq.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_gpio/mss_gpio.o: CFLAGS=$(CFLAGS_GCCEXT)

=== envm-wrapper/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# eNVM Compression Wrapper

COMPRESS=tools/compression/hss-deflate.py

OBJS-envm-wrapper = \
	envm-wrapper/envm-wrapper_crt.o \
	envm-wrapper/envm-wrapper_validate_crc.o \
	envm-wrapper/envm-wrapper_stubs.o \
	\
	application/hart0/hss_clock.o \
	init/hss_sys_setup.o \
	modules/misc/hss_crc32.o \
	baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_l2_cache.o \
	modules/misc/csr_helper.o \
	modules/misc/assert.o \
	modules/misc/c_stubs.o \
	modules/misc/stack_guard.o \
	thirdparty/miniz/miniz.o

#ifndef CONFIG_CODE_SIGNING
OBJS-envm-wrapper += \
       baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_nwc_init.o \
       baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_pll.o \
       baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_io.o \
       baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/nwc/mss_sgmii.o \
       baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/common/mss_peripherals.o \
       baremetal/polarfire-soc-bare-metal-library/src/platform/mpfs_hal/startup_gcc/mss_utils.o \
       baremetal/polarfire-soc-bare-metal-library/src/platform/drivers/mss/mss_mmuart/mss_uart.o \

#endif


EXTRA_OBJS-envm-wrapper =

LINKER_SCRIPT-envm-wrapper = envm-wrapper/envm-wrapper.ld

COMPRESSED_TARGET=$(BINDIR)/$(TARGET-l2scratch:.elf=.bin.deflate)

envm-wrapper/envm-wrapper_crt.o: $(COMPRESSED_TARGET) 
thirdparty/miniz/miniz.o: CFLAGS=$(CFLAGS_GCCEXT) -DMINIZ_NO_STDIO -DMINIZ_NO_TIME
envm-wrapper/envm-wrapper_validate_crc.o: CFLAGS=$(CFLAGS_GCCEXT)

define common-boot-mode-programmer
	-$(RM) -r $(BINDIR)/bootmode1
	[ "$(SC_INSTALL_DIR)" ] || ( echo "SC_INSTALL_DIR environment variable is unset"; exit 1 )
	[ -d $(SC_INSTALL_DIR) ] || ( echo "SoftConsole subdirectory >>$(SC_INSTALL_DIR)<< does not exist."; exit 2 )
	$(MPFS_BOOTMODE_PROGRAMMER) --workdir `pwd`/Default --die $(DIE) --package $(PACKAGE) --bootmode $(BOOTMODE) $(1) $(2)
endef


MPFS_BOOTMODE_PROGRAMMER_VERSION := $(findstring v3.6,$(shell $(MPFS_BOOTMODE_PROGRAMMER) --help))
EXPECTED_MPFS_BOOTMODE_PROGRAMMER_VERSION := v3.6
ifneq ($(MPFS_BOOTMODE_PROGRAMMER_VERSION),$(EXPECTED_MPFS_BOOTMODE_PROGRAMMER_VERSION))
  $(info INFO: Expected mpfsBootmodeProgrammer.jar version $(EXPECTED_MPFS_BOOTMODE_PROGRAMMER_VERSION) but found $(MPFS_BOOTMODE_PROGRAMMER_VERSION))
  $(info INFO: This version of the HSS relies on SoftConsole v2021.3 or later)
endif

$(TARGET-envm-wrapper): LIBS:=
$(TARGET-envm-wrapper): $(COMPRESSED_TARGET) $(OBJS-envm-wrapper)
	$(call main-build-target,envm-wrapper)
	@$(ECHO) " BIN       `basename $@ .elf`.bin"
	$(OBJCOPY) -O binary $(BINDIR)/$@ $(BINDIR)/`basename $@ .elf`.bin
	@$(ECHO) " HEX       `basename $@ .elf`.hex";
	$(call common-boot-mode-programmer,--dryrun,`basename $@`)
	@$(CP) $(BINDIR)/bootmode1/hss-envm-wrapper-bm1-p0.hex $(BINDIR)/`basename $@ .elf`.${BOARD}.hex
	$(SIZE) $(BINDIR)/$(TARGET-envm-wrapper) 2>/dev/null

$(COMPRESSED_TARGET): $(BINDIR)/$(TARGET-l2scratch:.elf=.bin) $(COMPRESS)
	@$(ECHO) " COMPRESS  $<"
	$(PYTHON) $(COMPRESS) $< $@

envm-wrapper_clean:
	-$(RM) $(COMPRESSED_TARGET) $(OBJS-envm-wrapper) $(BINDIR)/$(TARGET-envm-wrapper) $(BINDIR)/`basename $(TARGET-envm-wrapper) .elf`.sym $(BINDIR)/`basename $(TARGET-envm-wrapper) .elf`.bin

HEX_FILE-envm-wrapper=$(BINDIR)/$(TARGET-envm-wrapper:.elf=.hex)
BIN_FILE-envm-wrapper=$(BINDIR)/$(TARGET-envm-wrapper:.elf=.bin)

BIN_FILE-envm-wrapper: $(TARGET-envm-wrapper)

BOOTMODE?=1
PACKAGE?=FCVG484
DIE?=MPFS250T_ES
FPGENPROG?=/opt/microsemi/Libero_SoC_v2021.2/Libero/bin64/fpgenprog
FPGENPROG:=$(FPGENPROG:_bin=)

program: $(BIN_FILE-envm-wrapper)
	$(call common-boot-mode-programmer,,$(TARGET-envm-wrapper))

verify: $(BIN_FILE-envm-wrapper)
	$(call common-boot-mode-programmer,--verify,$(TARGET-envm-wrapper))

=== init/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Initialization Routines

EXTRA_SRCS-y += \
	init/hss_ddr_init.c \
	init/hss_boot_init.c \
	init/hss_sys_setup.c \

EXTRA_SRCS-y += \
	init/hss_usb_init.c

EXTRA_SRCS-$(CONFIG_USE_IHC) += \
	init/hss_ihc_init.c

EXTRA_SRCS-$(CONFIG_USE_PCIE) += \
	init/hss_pcie_init.c

EXTRA_SRCS-$(CONFIG_USE_PDMA) += \
	init/hss_pdma_init.c \

EXTRA_SRCS-$(CONFIG_OPENSBI) += \
        init/hss_opensbi_init.c

INCLUDES +=\
	-Ibaremetal/drivers/mss/mss_usb \

init/hss_ddr_init.o: CFLAGS=$(CFLAGS_GCCEXT)
init/hss_pdma_init.o: CFLAGS=$(CFLAGS_GCCEXT)
init/hss_boot_init.o: CFLAGS=$(CFLAGS_GCCEXT)
init/hss_opensbi_init.o: CFLAGS=$(CFLAGS_GCCEXT)
init/hss_sys_setup.o: CFLAGS=$(CFLAGS_GCCEXT)
init/hss_pcie_init.o: CFLAGS=$(CFLAGS_GCCEXT)
init/hss_usb_init.o: CFLAGS=$(CFLAGS_GCCEXT)
init/hss_ihc_init.o: CFLAGS=$(CFLAGS_GCCEXT)

=== services/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Services

include services/beu/Makefile
include services/boot/Makefile
include services/crypto/Makefile
include services/ddr/Makefile
include services/goto/Makefile
include services/ipi_poll/Makefile
include services/mmc/Makefile
include services/opensbi/Makefile
include services/powermode/Makefile
include services/qspi/Makefile
include services/scrub/Makefile
include services/sgdma/Makefile
include services/spi/Makefile
include services/tinycli/Makefile
include services/uart/Makefile
include services/usbdmsc/Makefile
include services/wdog/Makefile
include services/ymodem/Makefile

=== boards/aries-m100pfsevp/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Defines target-specific build-rules variables, extra sources and include paths
#

#
# The ARIES Embedded module M100PFS on the board M100PFSEVP
#
$(info aries-m100pfsevp selected)

BINDIR=Default
TARGET-l2scratch=hss-l2scratch.elf
TARGET-envm-wrapper=hss-envm-wrapper.elf
RISCV_TARGET=$(TARGET-l2scratch) $(TARGET-envm-wrapper)
TARGET:=$(RISCV_TARGET)

LINKER_SCRIPT-l2scratch=boards/${BOARD}/hss-l2scratch.ld

CONFIG_PLATFORM_MPFS=y
PLATFORM_CFLAGS += -DCONFIG_PLATFORM_MPFS=1 -DCONFIG_MODULE_M100PFS=1 -DCONFIG_BOARD_M100PFSEVP=1
BOARD_DIR=boards/aries-m100pfsevp

INCLUDES += \
	-I$(BOARD_DIR)/mpfs_hal_config/\
	-I$(BOARD_DIR)/fpga_design_config/\
	-I$(BOARD_DIR)/ \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform \

EXTRA_SRCS-y += \
	$(BOARD_DIR)/hss_uart_init.c \
        $(BOARD_DIR)/uart_helper.c \
        $(BOARD_DIR)/hss_board_init.c \

EXTRA_SRCS-$(CONFIG_USE_LOGO) += \
        $(BOARD_DIR)/hss_logo_init.c

$(BOARD_DIR)/hss_uart_init.o: CFLAGS=$(CFLAGS_GCCEXT)

EXTRA_OBJS-$(CONFIG_SERVICE_BOOT_USE_PAYLOAD) += $(BOARD_DIR)/payload.o
$(BOARD_DIR)/payload.o: $(BOARD_DIR)/payload.bin
	$(LD) -r -b binary $< -o $@

################################################################################################
#
# Extra hardware dependency rules for YMODEM
#

INCLUDES += \
	-Ibaremetal/ \
	-Ibaremetal/drivers/winbond_w25n01gv \

EXTRA_SRCS-$(CONFIG_SERVICE_QSPI) += \
	baremetal/drivers/winbond_w25n01gv/winbond_w25n01gv.c

baremetal/drivers/winbond_w25n01gv/winbond_w25n01gv.o: CFLAGS=$(CFLAGS_GCCEXT)

################################################################################################
#
# Linker Scripts
#

$(BOARD_DIR)/hss-l2scratch.ld: $(BOARD_DIR)/hss-l2scratch.lds config.h

################################################################################################

#
# Extra dependency rules for auto-generated configuration files (from Libero XML)
#

SOC_CONFIG_FILES =  \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_ddr_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_mss_cfm.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_mss_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sgmii_cfm.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sgmii_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sysreg.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_mss_clks.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_io_bank.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_mode.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_off_mode.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_options.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_segs.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddrc.h \
	$(BOARD_DIR)/fpga_design_config/general/hw_gen_peripherals.h \
	$(BOARD_DIR)/fpga_design_config/fpga_design_config.h \
	$(BOARD_DIR)/fpga_design_config/io/hw_hsio_mux.h \
	$(BOARD_DIR)/fpga_design_config/io/hw_mssio_mux.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_apb_split.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_cache.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_memory.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_crypto.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic2.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_gem0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_gem1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_mmc.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_scb.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_trace.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_usb.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart2.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart3.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart4.h \
	$(BOARD_DIR)/fpga_design_config/sgmii/hw_sgmii_tip.h \

config.h: $(SOC_CONFIG_FILES)
$(SOC_CONFIG_FILES): $(subst $\",,$(CONFIG_SOC_FPGA_DESIGN_XML))
	@$(ECHO) " MPFSCFGGEN    $<";
	$(PYTHON) tools/polarfire-soc-configuration-generator/mpfs_configuration_generator.py $< $(BOARD_DIR)

$(RISCV_TARGET): $(SOC_CONFIG_FILES)

=== boards/custom-board-design/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Defines target-specific build-rules variables, extra sources and include paths
#

$(info custom-board-design selected)

BINDIR=Default
TARGET-l2scratch=hss-l2scratch.elf
TARGET-envm-wrapper=hss-envm-wrapper.elf
RISCV_TARGET=$(TARGET-l2scratch) $(TARGET-envm-wrapper)
TARGET:=$(RISCV_TARGET)

LINKER_SCRIPT-l2scratch=boards/${BOARD}/hss-l2scratch.ld

CONFIG_PLATFORM_MPFS=y
PLATFORM_CFLAGS += -DCONFIG_PLATFORM_MPFS=1
BOARD_DIR=boards/custom-board-design

INCLUDES += \
	-I$(BOARD_DIR)/mpfs_hal_config/\
	-I$(BOARD_DIR)/fpga_design_config/\
	-I$(BOARD_DIR)/ \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform \

EXTRA_SRCS-y += \
	$(BOARD_DIR)/hss_uart_init.c \
        $(BOARD_DIR)/uart_helper.c \
        $(BOARD_DIR)/hss_board_init.c \

EXTRA_SRCS-$(CONFIG_USE_LOGO) += \
        $(BOARD_DIR)/hss_logo_init.c

$(BOARD_DIR)/hss_uart_init.o: CFLAGS=$(CFLAGS_GCCEXT)

EXTRA_OBJS-$(CONFIG_SERVICE_BOOT_USE_PAYLOAD) += $(BOARD_DIR)/payload.o
$(BOARD_DIR)/payload.o: $(BOARD_DIR)/payload.bin
	$(LD) -r -b binary $< -o $@

################################################################################################
#
# Extra hardware dependency rules for QSPI
#

INCLUDES += \
	-Ibaremetal/ \
	-Ibaremetal/drivers/winbond_w25n01gv \

baremetal/drivers/winbond_w25n01gv/winbond_w25n01gv.o: CFLAGS=$(CFLAGS_GCCEXT)

################################################################################################
#
# Linker Scripts
#

$(BOARD_DIR)/hss-l2scratch.ld: $(BOARD_DIR)/hss-l2scratch.lds config.h

################################################################################################

#
# Extra dependency rules for auto-generated configuration files (from Libero XML)
#

SOC_CONFIG_FILES =  \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_ddr_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_mss_cfm.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_mss_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sgmii_cfm.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sgmii_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sysreg.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_mss_clks.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_io_bank.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_mode.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_off_mode.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_options.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_segs.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddrc.h \
	$(BOARD_DIR)/fpga_design_config/general/hw_gen_peripherals.h \
	$(BOARD_DIR)/fpga_design_config/fpga_design_config.h \
	$(BOARD_DIR)/fpga_design_config/io/hw_hsio_mux.h \
	$(BOARD_DIR)/fpga_design_config/io/hw_mssio_mux.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_apb_split.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_cache.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_memory.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_crypto.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic2.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_gem0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_gem1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_mmc.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_scb.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_trace.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_usb.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart2.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart3.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart4.h \
	$(BOARD_DIR)/fpga_design_config/sgmii/hw_sgmii_tip.h \

config.h: $(SOC_CONFIG_FILES)
$(SOC_CONFIG_FILES): $(subst $\",,$(CONFIG_SOC_FPGA_DESIGN_XML))
	@$(ECHO) " MPFSCFGGEN    $<";
	$(PYTHON) tools/polarfire-soc-configuration-generator/mpfs_configuration_generator.py $< $(BOARD_DIR)

$(RISCV_TARGET): $(SOC_CONFIG_FILES)

=== boards/mpfs-icicle-kit-es/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Defines target-specific build-rules variables, extra sources and include paths
#

#
# Confusingly, the MPFS-ICICLE-KIT-ES is platform MPFS
#
$(info mpfs-icicle-kit-es selected)

BINDIR=Default
TARGET-l2scratch=hss-l2scratch.elf
TARGET-envm-wrapper=hss-envm-wrapper.elf
RISCV_TARGET=$(TARGET-l2scratch) $(TARGET-envm-wrapper)
TARGET:=$(RISCV_TARGET)

LINKER_SCRIPT-l2scratch=boards/${BOARD}/hss-l2scratch.ld

CONFIG_PLATFORM_MPFS=y
PLATFORM_CFLAGS += -DCONFIG_PLATFORM_MPFS=1
BOARD_DIR=boards/mpfs-icicle-kit-es

INCLUDES += \
	-I$(BOARD_DIR)/mpfs_hal_config/\
	-I$(BOARD_DIR)/fpga_design_config/\
	-I$(BOARD_DIR)/ \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform \

EXTRA_SRCS-y += \
	$(BOARD_DIR)/hss_uart_init.c \
        $(BOARD_DIR)/uart_helper.c \
        $(BOARD_DIR)/hss_board_init.c \

EXTRA_SRCS-$(CONFIG_USE_LOGO) += \
        init/hss_logo_init.c

$(BOARD_DIR)/hss_uart_init.o: CFLAGS=$(CFLAGS_GCCEXT)

EXTRA_OBJS-$(CONFIG_SERVICE_BOOT_USE_PAYLOAD) += $(BOARD_DIR)/payload.o
$(BOARD_DIR)/payload.o: $(BOARD_DIR)/payload.bin
	$(LD) -r -b binary $< -o $@

################################################################################################
#
# Extra hardware dependency rules for QSPI
#

INCLUDES += \
	-Ibaremetal/ \

ifdef CONFIG_SERVICE_QSPI_WINBOND_W25N01GV
INCLUDES += \
	-Ibaremetal/drivers/winbond_w25n01gv \

EXTRA_SRCS-$(CONFIG_SERVICE_QSPI) += \
	baremetal/drivers/winbond_w25n01gv/winbond_w25n01gv.c
baremetal/drivers/winbond_w25n01gv/winbond_w25n01gv.o: CFLAGS=$(CFLAGS_GCCEXT)
endif

ifdef CONFIG_SERVICE_QSPI_MICRON_MQ25T
INCLUDES += \
	-Ibaremetal/drivers/micron_mt25q \

EXTRA_SRCS-$(CONFIG_SERVICE_QSPI) += \
	baremetal/drivers/micron_mt25q/micron_mt25q.c
baremetal/drivers/micron_mt25q/micron_mt25q.o: CFLAGS=$(CFLAGS_GCCEXT)
endif


################################################################################################
#
# Linker Scripts
#

$(BOARD_DIR)/hss-l2scratch.ld: $(BOARD_DIR)/hss-l2scratch.lds config.h

################################################################################################

#
# Extra dependency rules for auto-generated configuration files (from Libero XML)
#

SOC_CONFIG_FILES =  \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_ddr_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_mss_cfm.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_mss_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sgmii_cfm.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sgmii_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sysreg.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_mss_clks.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_io_bank.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_mode.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_off_mode.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_options.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_segs.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddrc.h \
	$(BOARD_DIR)/fpga_design_config/general/hw_gen_peripherals.h \
	$(BOARD_DIR)/fpga_design_config/fpga_design_config.h \
	$(BOARD_DIR)/fpga_design_config/io/hw_hsio_mux.h \
	$(BOARD_DIR)/fpga_design_config/io/hw_mssio_mux.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_apb_split.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_cache.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_memory.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_crypto.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic2.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_gem0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_gem1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_mmc.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_scb.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_trace.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_usb.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart2.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart3.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart4.h \
	$(BOARD_DIR)/fpga_design_config/sgmii/hw_sgmii_tip.h \

config.h: $(SOC_CONFIG_FILES)
$(SOC_CONFIG_FILES): $(subst $\",,$(CONFIG_SOC_FPGA_DESIGN_XML))
	@$(ECHO) " MPFSCFGGEN    $<";
	$(PYTHON) tools/polarfire-soc-configuration-generator/mpfs_configuration_generator.py $< $(BOARD_DIR)

$(RISCV_TARGET): $(SOC_CONFIG_FILES)

=== boards/mpfs-sev-kit/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2022 Microchip FPGA Embedded Systems Solutions.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Defines target-specific build-rules variables, extra sources and include paths
#

#
# Confusingly, the CONFIG_MODULE_SEV_KIT is platform MPFS
#
$(info mpfs-sev-kit selected)

BINDIR=Default
TARGET-l2scratch=hss-l2scratch.elf
TARGET-envm-wrapper=hss-envm-wrapper.elf
RISCV_TARGET=$(TARGET-l2scratch) $(TARGET-envm-wrapper)
TARGET:=$(RISCV_TARGET)

LINKER_SCRIPT-l2scratch=boards/${BOARD}/hss-l2scratch.ld

CONFIG_PLATFORM_MPFS=y
PLATFORM_CFLAGS += -DCONFIG_PLATFORM_MPFS=1 -DCONFIG_MODULE_SEV_KIT=1
BOARD_DIR=boards/mpfs-sev-kit

INCLUDES += \
	-I$(BOARD_DIR)/mpfs_hal_config/\
	-I$(BOARD_DIR)/fpga_design_config/\
	-I$(BOARD_DIR)/ \
	-Ibaremetal/polarfire-soc-bare-metal-library/src/platform \

EXTRA_SRCS-y += \
	$(BOARD_DIR)/hss_uart_init.c \
        $(BOARD_DIR)/uart_helper.c \
        $(BOARD_DIR)/hss_board_init.c \

EXTRA_SRCS-$(CONFIG_USE_LOGO) += \
        init/hss_logo_init.c

$(BOARD_DIR)/hss_uart_init.o: CFLAGS=$(CFLAGS_GCCEXT)

EXTRA_OBJS-$(CONFIG_SERVICE_BOOT_USE_PAYLOAD) += $(BOARD_DIR)/payload.o
$(BOARD_DIR)/payload.o: $(BOARD_DIR)/payload.bin
	$(LD) -r -b binary $< -o $@

################################################################################################
#
# Extra hardware dependency rules for YMODEM
#

INCLUDES += \
	-Ibaremetal/ \

EXTRA_SRCS-$(CONFIG_SERVICE_YMODEM) += \
	baremetal/drivers/mss_envm/mss_envm.c

EXTRA_SRCS-$(CONFIG_SERVICE_QSPI) += \
	baremetal/drivers/winbond_w25n01gv/winbond_w25n01gv.c

baremetal/drivers/winbond_w25n01gv/winbond_w25n01gv.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/drivers/micron_mt25q/micron_mt25q.o: CFLAGS=$(CFLAGS_GCCEXT)
baremetal/drivers/mss_envm/mss_envm.o: CFLAGS=$(CFLAGS_GCCEXT)

################################################################################################
#
# Linker Scripts
#

$(BOARD_DIR)/hss-l2scratch.ld: $(BOARD_DIR)/hss-l2scratch.lds config.h

################################################################################################

#
# Extra dependency rules for auto-generated configuration files (from Libero XML)
#

SOC_CONFIG_FILES =  \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_ddr_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_mss_cfm.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_mss_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sgmii_cfm.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sgmii_pll.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_clk_sysreg.h \
	$(BOARD_DIR)/fpga_design_config/clocks/hw_mss_clks.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_io_bank.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_mode.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_off_mode.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_options.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddr_segs.h \
	$(BOARD_DIR)/fpga_design_config/ddr/hw_ddrc.h \
	$(BOARD_DIR)/fpga_design_config/general/hw_gen_peripherals.h \
	$(BOARD_DIR)/fpga_design_config/fpga_design_config.h \
	$(BOARD_DIR)/fpga_design_config/io/hw_hsio_mux.h \
	$(BOARD_DIR)/fpga_design_config/io/hw_mssio_mux.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_apb_split.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_cache.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_memory.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_crypto.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_fic2.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_gem0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_gem1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_mmc.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_scb.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_trace.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_mpu_usb.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart0.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart1.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart2.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart3.h \
	$(BOARD_DIR)/fpga_design_config/memory_map/hw_pmp_hart4.h \
	$(BOARD_DIR)/fpga_design_config/sgmii/hw_sgmii_tip.h \

config.h: $(SOC_CONFIG_FILES)
$(SOC_CONFIG_FILES): $(subst $\",,$(CONFIG_SOC_FPGA_DESIGN_XML))
	@$(ECHO) " MPFSCFGGEN    $<";
	$(PYTHON) tools/polarfire-soc-configuration-generator/mpfs_configuration_generator.py $< $(BOARD_DIR)

$(RISCV_TARGET): $(SOC_CONFIG_FILES)

=== modules/compression/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Compression Utilities

SRCS-$(CONFIG_COMPRESSION) += \
    modules/compression/hss_decompress.c \

SRCS-$(CONFIG_COMPRESSION_MINIZ) += \
    thirdparty/miniz/miniz.c \

INCLUDES +=\
    -I./modules/compression \
    -I./thirdparty/miniz \

thirdparty/miniz/miniz.o: CFLAGS+=-DMINIZ_NO_STDIO -DMINIZ_NO_TIME

=== modules/crypto/Makefile ===
#
# MPFS HSS Embedded Software
#
# Copyright 2019-2021 Microchip Corporation.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.
#
#
# Compression Utilities

INCLUDES +=\
	-I./modules/crypto \

#
# Boot Image Signing
#
ifdef CONFIG_CRYPTO_SIGNING
x509-ec-sepc384r1-public.h: $(subst $\",,$(CONFIG_CRYPTO_SIGNING_KEY_PUBLIC))
	tools/secure-boot/der_to_c_header.py $< x509-ec-secp384r1-public.h

#
# libecc
#

ifdef CONFIG_CRYPTO_LIBECC
SRCS-$(CONFIG_CRYPTO_LIBECC) += \
	modules/crypto/hss_crypto_libecc.c \
	modules/crypto/random.c \
	thirdparty/libecc/src/curves/aff_pt.c \
	thirdparty/libecc/src/curves/aff_pt_edwards.c \
	thirdparty/libecc/src/curves/aff_pt_montgomery.c \
	thirdparty/libecc/src/curves/curves.c \
	thirdparty/libecc/src/curves/ec_edwards.c \
	thirdparty/libecc/src/curves/ec_montgomery.c \
	thirdparty/libecc/src/curves/ec_params.c \
	thirdparty/libecc/src/curves/ec_shortw.c \
	thirdparty/libecc/src/curves/prj_pt.c \
	thirdparty/libecc/src/curves/prj_pt_monty.c \
	thirdparty/libecc/src/fp/fp_add.c \
	thirdparty/libecc/src/fp/fp.c \
	thirdparty/libecc/src/fp/fp_montgomery.c \
	thirdparty/libecc/src/fp/fp_mul.c \
	thirdparty/libecc/src/fp/fp_mul_redc1.c \
	thirdparty/libecc/src/fp/fp_pow.c \
	thirdparty/libecc/src/fp/fp_rand.c \
	thirdparty/libecc/src/fp/fp_sqrt.c \
	thirdparty/libecc/src/hash/hash_algs.c \
	thirdparty/libecc/src/hash/hmac.c \
	thirdparty/libecc/src/hash/sha224.c \
	thirdparty/libecc/src/hash/sha256.c \
	thirdparty/libecc/src/hash/sha3-224.c \
	thirdparty/libecc/src/hash/sha3-256.c \
	thirdparty/libecc/src/hash/sha3-384.c \
	thirdparty/libecc/src/hash/sha3-512.c \
	thirdparty/libecc/src/hash/sha384.c \
	thirdparty/libecc/src/hash/sha3.c \
	thirdparty/libecc/src/hash/sha512-224.c \
	thirdparty/libecc/src/hash/sha512-256.c \
	thirdparty/libecc/src/hash/sha512_core.c \
	thirdparty/libecc/src/hash/sha512.c \
	thirdparty/libecc/src/hash/shake256.c \
	thirdparty/libecc/src/hash/shake.c \
	thirdparty/libecc/src/hash/sm3.c \
	thirdparty/libecc/src/hash/streebog.c \
	thirdparty/libecc/src/nn/nn_add.c \
	thirdparty/libecc/src/nn/nn.c \
	thirdparty/libecc/src/nn/nn_div.c \
	thirdparty/libecc/src/nn/nn_logical.c \
	thirdparty/libecc/src/nn/nn_modinv.c \
	thirdparty/libecc/src/nn/nn_mul.c \
	thirdparty/libecc/src/nn/nn_mul_redc1.c \
	thirdparty/libecc/src/nn/nn_rand.c \
	thirdparty/libecc/src/sig/decdsa.c \
	thirdparty/libecc/src/sig/ecdsa_common.c \
	thirdparty/libecc/src/sig/ecdsa.c \
	thirdparty/libecc/src/sig/ecfsdsa.c \
	thirdparty/libecc/src/sig/ecgdsa.c \
	thirdparty/libecc/src/sig/eckcdsa.c \
	thirdparty/libecc/src/sig/ec_key.c \
	thirdparty/libecc/src/sig/ecosdsa.c \
	thirdparty/libecc/src/sig/ecrdsa.c \
	thirdparty/libecc/src/sig/ecsdsa_common.c \
	thirdparty/libecc/src/sig/ecsdsa.c \
	thirdparty/libecc/src/sig/eddsa.c \
	thirdparty/libecc/src/sig/sig_algs.c \
	thirdparty/libecc/src/sig/sm2.c \
	thirdparty/libecc/src/utils/utils.c \

INCLUDES +=\
	-I./thirdparty/libecc/src/ \

LIBECC_OVERRIDE_FLAGS=-DWITH_LIBECC_CONFIG_OVERRIDE -DWITH_CURVE_SECP384R1 -DWITH_HASH_SHA384 -DWITH_HASH_SHA512 -DWITH_HASH_SHA512_256 -DWITH_SIG_ECDSA -mabi=$(PLATFORM_RISCV_ABI) -march=$(PLATFORM_RISCV_ISA) -ffunction-sections -fdata-sections

modules/crypto/hss_crypto_libecc.o: x509-ec-sepc384r1-public.h
modules/crypto/hss_crypto_libecc.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/external_deps/rand.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)

thirdparty/libecc/src/curves/aff_pt.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/curves/aff_pt_edwards.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/curves/aff_pt_montgomery.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/curves/curves.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/curves/ec_edwards.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/curves/ec_montgomery.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/curves/ec_params.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/curves/ec_shortw.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/curves/prj_pt.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/curves/prj_pt_monty.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/fp/fp_add.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/fp/fp.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/fp/fp_montgomery.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/fp/fp_mul.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/fp/fp_mul_redc1.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/fp/fp_pow.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/fp/fp_rand.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/fp/fp_sqrt.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/hash_algs.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/hmac.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha224.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha256.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha3-224.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha3-256.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha3-384.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha3-512.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha384.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha3.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha512-224.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha512-256.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha512_core.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sha512.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/shake256.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/shake.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/sm3.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/hash/streebog.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/nn/nn_add.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/nn/nn.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/nn/nn_div.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/nn/nn_logical.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/nn/nn_modinv.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/nn/nn_mul.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/nn/nn_mul_redc1.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/nn/nn_rand.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/decdsa.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/ecdsa_common.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/ecdsa.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/ecfsdsa.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/ecgdsa.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/eckcdsa.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/ec_key.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/ecosdsa.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/ecrdsa.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/ecsdsa_common.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/ecsdsa.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/eddsa.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/sig_algs.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/sig/sm2.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
thirdparty/libecc/src/utils/utils.o: CFLAGS=$(LIBECC_OVERRIDE_FLAGS) $(CFLAGS_GCCEXT)
endif

#
# User Crypto
#
ifdef CONFIG_CRYPTO_USER_CRYPTO
SRCS-$(CONFIG_CRYPTO_USER_CRYPTO) += \
    modules/crypto/hss_crypto_cal.c

modules/crypto/hss_crypto_cal.o: x509-ec-sepc384r1-public.h
modules/crypto/hss_crypto_cal.o: CFLAGS=$(CFLAGS_GCCEXT)
endif
endif

=== debian/changelog ===
hart-software-services (2022.10-0ubuntu1~22.04.1) jammy-security; urgency=medium

  * No-change rebuild for -security pocket.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 28 Nov 2022 08:19:19 -0500

hart-software-services (2022.10-0ubuntu1~22.04) jammy; urgency=medium

  * Backport to jammy for hardware enablement (LP: #1997035)
  * Use new upstream release. All our patches are included. (LP: #1993528)
    We only package the payload generator which has the following upstream
    release changes:
    - ability added to override context boot image name in YAML
    - deprecated OpenSSL APIs replaced by current API

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Fri, 28 Oct 2022 14:13:48 +0200

=== debian/control ===
Source: hart-software-services
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (=13),
 libelf-dev,
 libssl-dev,
 libyaml-dev
Standards-Version: 4.6.0.1
Homepage: https://github.com/polarfire-soc/hart-software-services
Rules-Requires-Root: no

Package: hart-payload-generator
Architecture: amd64 arm64 riscv64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Hart Software Service Payload Generator
 This tool creates a formatted payload image for the Hart Software Service
 zero-stage bootloader on PolarFire SoC, given a configuration file and a
 set of ELF binaries.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --sourcedirectory=tools/hss-payload-generator

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.xz/hart-software-services-$1\.tar\.xz/ \
  https://github.com/polarfire-soc/hart-software-services/tags .*/v?(\d\S+)\.tar\.gz
